=begin
#The Plaid API

#The Plaid REST API. Please see https://plaid.com/docs/api for more details.

The version of the OpenAPI document: 2020-09-14_1.586.4

Generated by: https://openapi-generator.tech
OpenAPI Generator version: 6.3.0

=end

require 'date'
require 'time'

module Plaid
  # Calculated attributes derived from transaction-level data.
  class BaseReportAttributes
    # The number of NSF and overdraft fee transactions in the time range for the report in the given account.
    attr_accessor :nsf_overdraft_transactions_count

    # Prediction indicator of whether the account is a primary account. Only one account per account type across the items connected will have a value of true.
    attr_accessor :is_primary_account

    # Value ranging from 0-1. The higher the score, the more confident we are of the account being the primary account.
    attr_accessor :primary_account_score

    attr_accessor :total_inflow_amount

    attr_accessor :total_inflow_amount_30d

    attr_accessor :total_inflow_amount_60d

    attr_accessor :total_inflow_amount_90d

    attr_accessor :total_outflow_amount

    attr_accessor :total_outflow_amount_30d

    attr_accessor :total_outflow_amount_60d

    attr_accessor :total_outflow_amount_90d

    # Attribute mapping from ruby-style variable name to JSON key.
    def self.attribute_map
      {
        :'nsf_overdraft_transactions_count' => :'nsf_overdraft_transactions_count',
        :'is_primary_account' => :'is_primary_account',
        :'primary_account_score' => :'primary_account_score',
        :'total_inflow_amount' => :'total_inflow_amount',
        :'total_inflow_amount_30d' => :'total_inflow_amount_30d',
        :'total_inflow_amount_60d' => :'total_inflow_amount_60d',
        :'total_inflow_amount_90d' => :'total_inflow_amount_90d',
        :'total_outflow_amount' => :'total_outflow_amount',
        :'total_outflow_amount_30d' => :'total_outflow_amount_30d',
        :'total_outflow_amount_60d' => :'total_outflow_amount_60d',
        :'total_outflow_amount_90d' => :'total_outflow_amount_90d'
      }
    end

    # Returns all the JSON keys this model knows about
    def self.acceptable_attributes
      attribute_map.values
    end

    # Attribute type mapping.
    def self.openapi_types
      {
        :'nsf_overdraft_transactions_count' => :'Integer',
        :'is_primary_account' => :'Boolean',
        :'primary_account_score' => :'Float',
        :'total_inflow_amount' => :'TotalInflowAmount',
        :'total_inflow_amount_30d' => :'TotalInflowAmount30d',
        :'total_inflow_amount_60d' => :'TotalInflowAmount60d',
        :'total_inflow_amount_90d' => :'TotalInflowAmount90d',
        :'total_outflow_amount' => :'TotalOutflowAmount',
        :'total_outflow_amount_30d' => :'TotalOutflowAmount30d',
        :'total_outflow_amount_60d' => :'TotalOutflowAmount60d',
        :'total_outflow_amount_90d' => :'TotalOutflowAmount90d'
      }
    end

    # List of attributes with nullable: true
    def self.openapi_nullable
      Set.new([
        :'is_primary_account',
        :'primary_account_score',
        :'total_inflow_amount',
        :'total_inflow_amount_30d',
        :'total_inflow_amount_60d',
        :'total_inflow_amount_90d',
        :'total_outflow_amount',
        :'total_outflow_amount_30d',
        :'total_outflow_amount_60d',
        :'total_outflow_amount_90d'
      ])
    end

    # Initializes the object
    # @param [Hash] attributes Model attributes in the form of hash
    def initialize(attributes = {})
      if (!attributes.is_a?(Hash))
        fail ArgumentError, "The input argument (attributes) must be a hash in `Plaid::BaseReportAttributes` initialize method"
      end

      # check to see if the attribute exists and convert string to symbol for hash key
      attributes = attributes.each_with_object({}) { |(k, v), h|
        if (!self.class.attribute_map.key?(k.to_sym))
          fail ArgumentError, "`#{k}` is not a valid attribute in `Plaid::BaseReportAttributes`. Please check the name to make sure it's valid. List of attributes: " + self.class.attribute_map.keys.inspect
        end
        h[k.to_sym] = v
      }

      if attributes.key?(:'nsf_overdraft_transactions_count')
        self.nsf_overdraft_transactions_count = attributes[:'nsf_overdraft_transactions_count']
      end

      if attributes.key?(:'is_primary_account')
        self.is_primary_account = attributes[:'is_primary_account']
      end

      if attributes.key?(:'primary_account_score')
        self.primary_account_score = attributes[:'primary_account_score']
      end

      if attributes.key?(:'total_inflow_amount')
        self.total_inflow_amount = attributes[:'total_inflow_amount']
      end

      if attributes.key?(:'total_inflow_amount_30d')
        self.total_inflow_amount_30d = attributes[:'total_inflow_amount_30d']
      end

      if attributes.key?(:'total_inflow_amount_60d')
        self.total_inflow_amount_60d = attributes[:'total_inflow_amount_60d']
      end

      if attributes.key?(:'total_inflow_amount_90d')
        self.total_inflow_amount_90d = attributes[:'total_inflow_amount_90d']
      end

      if attributes.key?(:'total_outflow_amount')
        self.total_outflow_amount = attributes[:'total_outflow_amount']
      end

      if attributes.key?(:'total_outflow_amount_30d')
        self.total_outflow_amount_30d = attributes[:'total_outflow_amount_30d']
      end

      if attributes.key?(:'total_outflow_amount_60d')
        self.total_outflow_amount_60d = attributes[:'total_outflow_amount_60d']
      end

      if attributes.key?(:'total_outflow_amount_90d')
        self.total_outflow_amount_90d = attributes[:'total_outflow_amount_90d']
      end
    end

    # Show invalid properties with the reasons. Usually used together with valid?
    # @return Array for valid properties with the reasons
    def list_invalid_properties
      invalid_properties = Array.new
      invalid_properties
    end

    # Check to see if the all the properties in the model are valid
    # @return true if the model is valid
    def valid?
      true
    end

    # Checks equality by comparing each attribute.
    # @param [Object] Object to be compared
    def ==(o)
      return true if self.equal?(o)
      self.class == o.class &&
          nsf_overdraft_transactions_count == o.nsf_overdraft_transactions_count &&
          is_primary_account == o.is_primary_account &&
          primary_account_score == o.primary_account_score &&
          total_inflow_amount == o.total_inflow_amount &&
          total_inflow_amount_30d == o.total_inflow_amount_30d &&
          total_inflow_amount_60d == o.total_inflow_amount_60d &&
          total_inflow_amount_90d == o.total_inflow_amount_90d &&
          total_outflow_amount == o.total_outflow_amount &&
          total_outflow_amount_30d == o.total_outflow_amount_30d &&
          total_outflow_amount_60d == o.total_outflow_amount_60d &&
          total_outflow_amount_90d == o.total_outflow_amount_90d
    end

    # @see the `==` method
    # @param [Object] Object to be compared
    def eql?(o)
      self == o
    end

    # Calculates hash code according to all attributes.
    # @return [Integer] Hash code
    def hash
      [nsf_overdraft_transactions_count, is_primary_account, primary_account_score, total_inflow_amount, total_inflow_amount_30d, total_inflow_amount_60d, total_inflow_amount_90d, total_outflow_amount, total_outflow_amount_30d, total_outflow_amount_60d, total_outflow_amount_90d].hash
    end

    # Builds the object from hash
    # @param [Hash] attributes Model attributes in the form of hash
    # @return [Object] Returns the model itself
    def self.build_from_hash(attributes)
      new.build_from_hash(attributes)
    end

    # Builds the object from hash
    # @param [Hash] attributes Model attributes in the form of hash
    # @return [Object] Returns the model itself
    def build_from_hash(attributes)
      return nil unless attributes.is_a?(Hash)
      attributes = attributes.transform_keys(&:to_sym)
      self.class.openapi_types.each_pair do |key, type|
        if attributes[self.class.attribute_map[key]].nil? && self.class.openapi_nullable.include?(key)
          self.send("#{key}=", nil)
        elsif type =~ /\AArray<(.*)>/i
          # check to ensure the input is an array given that the attribute
          # is documented as an array but the input is not
          if attributes[self.class.attribute_map[key]].is_a?(Array)
            self.send("#{key}=", attributes[self.class.attribute_map[key]].map { |v| _deserialize($1, v) })
          end
        elsif !attributes[self.class.attribute_map[key]].nil?
          self.send("#{key}=", _deserialize(type, attributes[self.class.attribute_map[key]]))
        end
      end

      self
    end

    # Deserializes the data based on type
    # @param string type Data type
    # @param string value Value to be deserialized
    # @return [Object] Deserialized data
    def _deserialize(type, value)
      case type.to_sym
      when :Time
        Time.parse(value)
      when :Date
        Date.parse(value)
      when :String
        value.to_s
      when :Integer
        value.to_i
      when :Float
        value.to_f
      when :Boolean
        if value.to_s =~ /\A(true|t|yes|y|1)\z/i
          true
        else
          false
        end
      when :Object
        # generic object (usually a Hash), return directly
        value
      when /\AArray<(?<inner_type>.+)>\z/
        inner_type = Regexp.last_match[:inner_type]
        value.map { |v| _deserialize(inner_type, v) }
      when /\AHash<(?<k_type>.+?), (?<v_type>.+)>\z/
        k_type = Regexp.last_match[:k_type]
        v_type = Regexp.last_match[:v_type]
        {}.tap do |hash|
          value.each do |k, v|
            hash[_deserialize(k_type, k)] = _deserialize(v_type, v)
          end
        end
      else # model
        # models (e.g. Pet) or oneOf
        klass = Plaid.const_get(type)
        klass.respond_to?(:openapi_one_of) ? klass.build(value) : klass.build_from_hash(value)
      end
    end

    # Returns the string representation of the object
    # @return [String] String presentation of the object
    def to_s
      to_hash.to_s
    end

    # to_body is an alias to to_hash (backward compatibility)
    # @return [Hash] Returns the object in the form of hash
    def to_body
      to_hash
    end

    # Returns the object in the form of hash
    # @return [Hash] Returns the object in the form of hash
    def to_hash
      hash = {}
      self.class.attribute_map.each_pair do |attr, param|
        value = self.send(attr)
        if value.nil?
          is_nullable = self.class.openapi_nullable.include?(attr)
          next if !is_nullable || (is_nullable && !instance_variable_defined?(:"@#{attr}"))
        end

        hash[param] = _to_hash(value)
      end
      hash
    end

    # Outputs non-array value in the form of hash
    # For object, use to_hash. Otherwise, just return the value
    # @param [Object] value Any valid value
    # @return [Hash] Returns the value in the form of hash
    def _to_hash(value)
      if value.is_a?(Array)
        value.compact.map { |v| _to_hash(v) }
      elsif value.is_a?(Hash)
        {}.tap do |hash|
          value.each { |k, v| hash[k] = _to_hash(v) }
        end
      elsif value.respond_to? :to_hash
        value.to_hash
      else
        value
      end
    end

  end

end
